
/*  A Bison parser, made from elastic_p.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define YYLSP_NEEDED

#define	T_ARRAYCONS	257
#define	T_HASHCONS	258
#define	T_LE	259
#define	T_GE	260
#define	T_POW	261
#define	T_LSHIFT	262
#define	T_RSHIFT	263
#define	T_EQ	264
#define	T_NE	265
#define	T_LAND	266
#define	T_LOR	267
#define	T_POWASSIGN	268
#define	T_MULASSIGN	269
#define	T_DIVASSIGN	270
#define	T_MODASSIGN	271
#define	T_ADDASSIGN	272
#define	T_SUBASSIGN	273
#define	T_LSHIFTASSIGN	274
#define	T_RSHIFTASSIGN	275
#define	T_ANDASSIGN	276
#define	T_XORASSIGN	277
#define	T_ORASSIGN	278
#define	T_INC	279
#define	T_DEC	280
#define	T_IF	281
#define	T_ELSE	282
#define	T_WHILE	283
#define	T_DO	284
#define	T_FOR	285
#define	T_IN	286
#define	T_BREAK	287
#define	T_CONTINUE	288
#define	T_GOTO	289
#define	T_TRY	290
#define	T_CATCH	291
#define	T_THROW	292
#define	T_FUNCTION	293
#define	T_RETURN	294
#define	T_CLASS	295
#define	T_EXTENDS	296
#define	T_METHOD	297
#define	T_SUPER	298
#define	T_LOCAL	299
#define	T_STATIC	300
#define	T_PRIVATE	301
#define	T_PUBLIC	302
#define	T_PACKAGE	303
#define	T_IMPORT	304
#define	T_FROM	305
#define	T_QUALIFIER	306
#define	T_ELLIPSIS	307
#define	T_INUMBER	308
#define	T_FNUMBER	309
#define	T_CHAR	310
#define	T_SYMBOL	311
#define	T_STRING	312
#define	T_OBJECT	313
#define	T_KEYWORD	314
#define	T_CONSTSYM	315

#line 1 "elastic_p.y"

/* ==========================================================================
 * elastic.y
 * ==========================================================================
 * Parser for elastiC language.
 * --------------------------------------------------------------------------
 *   AUTHOR:  Marco Pantaleoni         E-mail: panta@elasticworld.org
 *
 *   Created: 1997
 *
 *   $Id$
 * --------------------------------------------------------------------------
 *    Copyright (C) 1997-2001 Marco Pantaleoni. All rights reserved.
 *
 *  The contents of this file are subject to the elastiC License version 1.0
 *  (the "elastiC License"); you may not use this file except in compliance
 *  with the elastiC License. You may obtain a copy of the elastiC License at
 *  http://www.elasticworld.org/LICENSE
 *
 *  IN NO EVENT SHALL THE AUTHOR OR DISTRIBUTORS BE LIABLE TO ANY PARTY
 *  FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 *  ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
 *  DERIVATIVES THEREOF, EVEN IF THE AUTHOR HAS BEEN ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 *
 *  THE AUTHOR AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
 *  IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHOR AND DISTRIBUTORS HAVE
 *  NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 *  MODIFICATIONS.
 *
 *  See the elastiC License for the specific language governing rights and
 *  limitations under the elastiC License.
 * ==========================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "elastic.h"
#include "ast.h"
#include "private.h"


int yyparse( void );
int yylex( void );
int yyerror( char *s );

static void saveLoc( ASTLocation *dst, void *src );
static EcUInt symconcat( EcUInt sym1, EcUInt sym2 );
static ASTNode listconcat( ASTNode l1, ASTNode l2 );

#define SAVE(dst,loc)		do { saveLoc( &(dst->tloc), &(loc) ); } while (0)

#define MAKEATOMLIST(el)	(makeList( FALSE, FALSE, NULL, (el) ))
#define MAKEDECLATOM(sym,init)	(makeDeclAtom( (sym), (init) ))
#define DECLSYM(t, sym)		(makeDecl( (t), MAKEATOMLIST(MAKEDECLATOM((sym), NULL)) ))
#define DECLVAR(t, var)		(DECLSYM( (t), makeSymbol( QSCOMP(QSYM(var), QSLEN(QSYM(var)) - 1) )))

#define YYERROR_VERBOSE 1

#line 65 "elastic_p.y"
typedef union {
	EcInt		icnst;          /* For returning numerical constants	     */
	EcFloat		fcnst;          /* For returning numerical constants	     */
	EcChar          ccnst;          /* For returning char constants	             */
	char           *strcnst;        /* For returning string constants or symbols */
	EC_OBJ          objcnst;        /* For returning object constants	     */
	ASTNode         ast;            /* Abstract Syntax Tree                      */
	EcUInt          sym;            /* Symbol                                    */
	struct {
		EcUInt  sym;
		ASTNode list;
	}               kwl;		/* Keyword Argument / Parameter List         */
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		392
#define	YYFLAG		-32768
#define	YYNTBASE	85

#define YYTRANSLATE(x) ((unsigned)(x) <= 315 ? yytranslate[x] : 145)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     3,     2,     2,     2,    75,    76,     2,     4,
     5,    73,    70,    69,    71,     2,    74,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    80,    84,     6,
    81,     7,    79,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    67,     2,    68,    77,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    82,    78,    83,    72,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     6,     8,    10,    12,    16,    18,    20,
    26,    30,    35,    37,    39,    41,    43,    48,    53,    59,
    64,    69,    75,    80,    83,    87,    92,    95,    99,   104,
   107,   111,   115,   118,   122,   126,   128,   132,   134,   137,
   140,   143,   146,   149,   152,   155,   158,   160,   164,   166,
   170,   174,   178,   180,   184,   188,   190,   194,   198,   200,
   204,   208,   212,   216,   218,   222,   226,   228,   232,   234,
   238,   240,   244,   246,   250,   252,   256,   258,   262,   264,
   270,   272,   276,   280,   284,   288,   292,   296,   300,   304,
   308,   312,   316,   320,   322,   326,   334,   340,   342,   344,
   346,   348,   350,   352,   354,   356,   358,   360,   362,   364,
   367,   370,   374,   376,   379,   381,   384,   390,   398,   404,
   412,   419,   427,   435,   438,   442,   445,   449,   452,   456,
   460,   464,   468,   474,   480,   484,   486,   489,   495,   502,
   505,   507,   511,   512,   514,   517,   524,   532,   540,   548,
   555,   562,   565,   569,   571,   574,   576,   578,   585,   589,
   594,   602,   607,   613,   617,   621,   625,   629,   632,   634,
   638,   639,   642,   644,   646,   650,   652,   654,   658,   662,
   664,   666,   668,   670,   673
};

static const short yyrhs[] = {    59,
     0,    60,     0,    61,     0,    66,     0,    63,     0,    64,
     0,     4,   111,     5,     0,    85,     0,    87,     0,    44,
     4,   126,     5,   114,     0,    86,     4,     5,     0,    86,
     4,    93,     5,     0,    88,     0,    89,     0,    90,     0,
   137,     0,    86,    67,   111,    68,     0,    67,    86,   139,
    68,     0,    67,    86,   139,    93,    68,     0,    67,    86,
    91,    68,     0,    67,    49,   139,    68,     0,    67,    49,
   139,    93,    68,     0,    67,    49,    91,    68,     0,     8,
    68,     0,     8,    93,    68,     0,     8,    93,    69,    68,
     0,     9,    68,     0,     9,    93,    68,     0,     9,    93,
    69,    68,     0,    65,   108,     0,    91,    65,   108,     0,
    91,    69,    93,     0,    65,   124,     0,    92,    65,   124,
     0,    92,    69,   125,     0,   108,     0,    93,    69,   108,
     0,    86,     0,    70,    94,     0,    71,    94,     0,    72,
    94,     0,     3,    94,     0,    30,    87,     0,    31,    87,
     0,    87,    30,     0,    87,    31,     0,    94,     0,    95,
    12,    94,     0,    95,     0,    96,    73,    95,     0,    96,
    74,    95,     0,    96,    75,    95,     0,    96,     0,    97,
    70,    96,     0,    97,    71,    96,     0,    97,     0,    98,
    13,    97,     0,    98,    14,    97,     0,    98,     0,    99,
     6,    98,     0,    99,     7,    98,     0,    99,    10,    98,
     0,    99,    11,    98,     0,    99,     0,   100,    15,    99,
     0,   100,    16,    99,     0,   100,     0,   101,    76,   100,
     0,   101,     0,   102,    77,   101,     0,   102,     0,   103,
    78,   102,     0,   103,     0,   104,    37,   103,     0,   104,
     0,   105,    17,   100,     0,   105,     0,   106,    18,   105,
     0,   106,     0,   106,    79,   111,    80,   107,     0,   107,
     0,    87,    81,   108,     0,    87,    19,   108,     0,    87,
    20,   108,     0,    87,    21,   108,     0,    87,    22,   108,
     0,    87,    23,   108,     0,    87,    24,   108,     0,    87,
    25,   108,     0,    87,    26,   108,     0,    87,    27,   108,
     0,    87,    28,   108,     0,    87,    29,   108,     0,    87,
     0,   109,    69,    87,     0,    67,   109,    68,    81,    67,
    93,    68,     0,    67,   109,    68,    81,   108,     0,   108,
     0,   110,     0,   113,     0,   114,     0,   116,     0,   117,
     0,   118,     0,   121,     0,   119,     0,   120,     0,   127,
     0,   133,     0,    65,   112,     0,    82,    83,     0,    82,
   115,    83,     0,   112,     0,   115,   112,     0,    84,     0,
   111,    84,     0,    32,     4,   111,     5,   112,     0,    32,
     4,   111,     5,   112,    33,   112,     0,    34,     4,   111,
     5,   112,     0,    35,   112,    34,     4,   111,     5,    84,
     0,    36,     4,   112,   116,     5,   112,     0,    36,     4,
   112,   116,   111,     5,   112,     0,    36,     4,   137,    37,
   111,     5,   112,     0,    45,    84,     0,    45,   111,    84,
     0,    38,    84,     0,    38,    59,    84,     0,    39,    84,
     0,    39,    59,    84,     0,    40,   139,    84,     0,    43,
   111,    84,     0,    55,   138,    84,     0,    56,   138,    55,
   140,    84,     0,    56,   138,    55,    73,    84,     0,    41,
   114,   122,     0,   123,     0,   122,   123,     0,    42,     4,
   138,     5,   114,     0,    42,     4,   138,   137,     5,   114,
     0,   137,   136,     0,   124,     0,   125,    69,   124,     0,
     0,   125,     0,   125,    58,     0,    44,   137,     4,   126,
     5,   114,     0,    51,    44,   137,     4,   126,     5,   114,
     0,    52,    44,   137,     4,   126,     5,   114,     0,    53,
    44,   137,     4,   126,     5,   114,     0,    52,    46,   139,
    47,   138,   129,     0,    53,    46,   139,    47,   138,   129,
     0,    82,    83,     0,    82,   130,    83,     0,   131,     0,
   130,   131,     0,   133,     0,   132,     0,    48,   139,     4,
   126,     5,   114,     0,    48,    92,   114,     0,    48,    92,
    58,   114,     0,    46,    48,   139,     4,   126,     5,   114,
     0,    46,    48,    92,   114,     0,    46,    48,    92,    58,
   114,     0,    50,   135,    84,     0,    51,   135,    84,     0,
    52,   135,    84,     0,    53,   135,    84,     0,   139,   136,
     0,   134,     0,   135,    69,   134,     0,     0,    81,   111,
     0,   138,     0,   139,     0,   138,    57,   139,     0,    62,
     0,   139,     0,   140,    69,   139,     0,    54,   138,    84,
     0,   141,     0,   112,     0,   128,     0,   142,     0,   143,
   142,     0,   143,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   145,   146,   147,   148,   149,   150,   151,   156,   157,   158,
   160,   161,   162,   163,   164,   168,   169,   173,   174,   175,
   177,   178,   179,   184,   185,   186,   190,   191,   192,   196,
   198,   200,   205,   207,   209,   214,   215,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   231,   232,   236,   237,
   238,   239,   243,   244,   245,   249,   250,   251,   255,   256,
   257,   258,   259,   263,   264,   265,   269,   270,   274,   275,
   279,   280,   284,   285,   289,   290,   294,   295,   299,   300,
   305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
   315,   316,   317,   321,   322,   326,   327,   331,   332,   336,
   337,   338,   339,   340,   341,   342,   343,   344,   345,   349,
   353,   354,   358,   359,   363,   364,   368,   369,   373,   374,
   375,   376,   377,   381,   382,   383,   384,   385,   386,   387,
   388,   392,   393,   394,   398,   402,   403,   407,   408,   414,
   418,   419,   423,   424,   425,   431,   433,   435,   437,   444,
   446,   451,   452,   456,   457,   461,   462,   466,   468,   471,
   474,   476,   479,   487,   488,   489,   490,   494,   498,   499,
   503,   504,   508,   512,   513,   517,   522,   523,   529,   533,
   534,   535,   539,   540,   546
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","'!'","'('",
"')'","'<'","'>'","\"#[\"","\"%[\"","\"<=\"","\">=\"","\"**\"","\"<<\"","\">>\"",
"T_EQ","T_NE","T_LAND","T_LOR","T_POWASSIGN","T_MULASSIGN","T_DIVASSIGN","T_MODASSIGN",
"T_ADDASSIGN","T_SUBASSIGN","T_LSHIFTASSIGN","T_RSHIFTASSIGN","T_ANDASSIGN",
"T_XORASSIGN","T_ORASSIGN","T_INC","T_DEC","T_IF","T_ELSE","T_WHILE","T_DO",
"T_FOR","T_IN","T_BREAK","T_CONTINUE","T_GOTO","T_TRY","T_CATCH","T_THROW","T_FUNCTION",
"T_RETURN","T_CLASS","T_EXTENDS","T_METHOD","T_SUPER","T_LOCAL","T_STATIC","T_PRIVATE",
"T_PUBLIC","T_PACKAGE","T_IMPORT","T_FROM","T_QUALIFIER","T_ELLIPSIS","T_INUMBER",
"T_FNUMBER","T_CHAR","T_SYMBOL","T_STRING","T_OBJECT","T_KEYWORD","T_CONSTSYM",
"'['","']'","','","'+'","'-'","'~'","'*'","'/'","'%'","'&'","'^'","'|'","'?'",
"':'","'='","'{'","'}'","';'","primary.expression","postfix.expression","lvalue.expression",
"method.call","array.construction","hash.construction","keyword.argument.list",
"keyword.parameter.list","argument.list","unary.expression","exponentiation.expression",
"multiplicative.expression","additive.expression","shift.expression","relational.expression",
"equality.expression","and.expression","exclusive.or.expression","inclusive.or.expression",
"in.expression","logical.and.expression","logical.or.expression","conditional.expression",
"assignment.expression","lvalue.list","sim.assignment.expression","expression",
"statement","labeled.statement","compound.statement","statement.list","expression.statement",
"selection.statement","iteration.statement","jump.statement","import.statement",
"try.statement","catch.list","catch.statement","parameter","basic.parameter.list",
"parameter.list","function.definition","class.definition","class.body","class.statement.list",
"class.statement","method.definition","declaration","decl.atom","decl.list",
"initialization","variable","qualified.symbol","symbol","symbol.list","package.declaration",
"package.statement","package.statement.list","translation.unit", NULL
};
#endif

static const short yyr1[] = {     0,
    85,    85,    85,    85,    85,    85,    85,    86,    86,    86,
    86,    86,    86,    86,    86,    87,    87,    88,    88,    88,
    88,    88,    88,    89,    89,    89,    90,    90,    90,    91,
    91,    91,    92,    92,    92,    93,    93,    94,    94,    94,
    94,    94,    94,    94,    94,    94,    95,    95,    96,    96,
    96,    96,    97,    97,    97,    98,    98,    98,    99,    99,
    99,    99,    99,   100,   100,   100,   101,   101,   102,   102,
   103,   103,   104,   104,   105,   105,   106,   106,   107,   107,
   108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
   108,   108,   108,   109,   109,   110,   110,   111,   111,   112,
   112,   112,   112,   112,   112,   112,   112,   112,   112,   113,
   114,   114,   115,   115,   116,   116,   117,   117,   118,   118,
   118,   118,   118,   119,   119,   119,   119,   119,   119,   119,
   119,   120,   120,   120,   121,   122,   122,   123,   123,   124,
   125,   125,   126,   126,   126,   127,   127,   127,   127,   128,
   128,   129,   129,   130,   130,   131,   131,   132,   132,   132,
   132,   132,   132,   133,   133,   133,   133,   134,   135,   135,
   136,   136,   137,   138,   138,   139,   140,   140,   141,   142,
   142,   142,   143,   143,   144
};

static const short yyr2[] = {     0,
     1,     1,     1,     1,     1,     1,     3,     1,     1,     5,
     3,     4,     1,     1,     1,     1,     4,     4,     5,     4,
     4,     5,     4,     2,     3,     4,     2,     3,     4,     2,
     3,     3,     2,     3,     3,     1,     3,     1,     2,     2,
     2,     2,     2,     2,     2,     2,     1,     3,     1,     3,
     3,     3,     1,     3,     3,     1,     3,     3,     1,     3,
     3,     3,     3,     1,     3,     3,     1,     3,     1,     3,
     1,     3,     1,     3,     1,     3,     1,     3,     1,     5,
     1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     1,     3,     7,     5,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
     2,     3,     1,     2,     1,     2,     5,     7,     5,     7,
     6,     7,     7,     2,     3,     2,     3,     2,     3,     3,
     3,     3,     5,     5,     3,     1,     2,     5,     6,     2,
     1,     3,     0,     1,     2,     6,     7,     7,     7,     6,
     6,     2,     3,     1,     2,     1,     1,     6,     3,     4,
     7,     4,     5,     3,     3,     3,     3,     2,     1,     3,
     0,     2,     1,     1,     3,     1,     1,     3,     3,     1,
     1,     1,     1,     2,     1
};

static const short yydefact[] = {     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     1,     2,     3,   176,     5,     6,
     0,     4,     0,     0,     0,     0,     0,   115,     8,    38,
     9,    13,    14,    15,    47,    49,    53,    56,    59,    64,
    67,    69,    71,    73,    75,    77,    79,    81,    98,    99,
     0,   181,   100,   101,   102,   103,   104,   106,   107,   105,
   108,   182,   109,    16,   173,   174,   180,   183,   185,     0,
     0,     9,    42,     0,    24,     0,    36,    27,     0,     0,
    43,    44,     0,     0,     0,     0,     0,     0,     0,   126,
     0,   128,     0,     0,     0,   143,     0,   124,     0,   169,
     0,   171,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   110,     0,     0,     9,     0,    39,    40,
    41,   111,   113,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    45,    46,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   116,     0,   184,     9,     7,    25,     0,    28,     0,
     0,     0,     0,     0,    16,   127,   129,   130,     0,   135,
   136,   131,   141,   144,     0,   171,   143,   125,     0,   164,
     0,   168,     0,   165,     0,     0,   166,     0,     0,   167,
   179,   132,     0,     0,     0,     0,     0,     0,     0,     0,
   112,   114,    11,     0,     0,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    82,    48,    50,    51,
    52,    54,    55,    57,    58,    60,    61,    62,    63,    65,
    66,    68,    70,    72,    74,    76,    78,     0,   175,    26,
    37,    29,     0,     0,     0,     0,     0,     0,   137,   145,
     0,     0,   140,     0,   170,   172,   143,   143,     0,   143,
     0,     0,   177,     0,    30,     0,    23,     0,    21,     0,
    20,    18,     0,     0,     9,    12,     0,    17,     0,   117,
   119,     0,     0,     0,     0,     0,   142,    10,     0,     0,
     0,     0,     0,     0,   134,     0,   133,    31,    32,    22,
    19,     0,    97,    80,     0,     0,   121,     0,     0,     0,
     0,   146,     0,     0,     0,   150,     0,   151,   178,    38,
     0,   118,   120,   122,   123,   138,     0,   147,   148,     0,
     0,     0,     0,     0,   152,     0,   154,   157,   156,   149,
    96,   139,     0,     0,     0,     0,   153,   155,     0,     0,
    33,     0,     0,     0,   159,   143,     0,   162,   143,   160,
    34,    35,     0,   163,     0,     0,     0,   158,   161,     0,
     0,     0
};

static const short yydefgoto[] = {    39,
    40,    41,    42,    43,    44,   217,   365,    86,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,   128,    60,    61,    62,    63,    64,   134,
    65,    66,    67,    68,    69,    70,   190,   191,   193,   194,
   195,    71,    72,   336,   356,   357,   358,    73,   110,   117,
   202,    74,    75,    76,   284,    77,    78,    79,   390
};

static const short yypact[] = {   377,
  1091,  1129,   719,   762,   186,   186,    66,    94,   572,   121,
   -30,    -8,     0,   -32,  1129,    45,   637,     0,    55,    23,
    77,     0,     0,     0,-32768,-32768,-32768,-32768,-32768,-32768,
   572,-32768,    83,  1091,  1091,  1091,   442,-32768,-32768,     7,
    16,-32768,-32768,-32768,-32768,   123,   153,   100,   178,   195,
   188,    76,    98,   137,   187,   212,     9,-32768,-32768,-32768,
   147,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   176,-32768,-32768,-32768,   377,   231,
    83,   213,-32768,   233,-32768,   194,-32768,-32768,   205,     7,
    12,    12,  1129,  1129,    74,    86,   206,   572,   167,-32768,
   173,-32768,   183,   234,   224,     0,   299,-32768,   225,-32768,
    53,   226,     0,    57,     0,     0,    85,     0,     0,    97,
   -24,    -9,    -2,-32768,   122,     6,   210,   215,-32768,-32768,
-32768,-32768,-32768,   507,   805,  1129,  1091,  1091,  1091,  1091,
  1091,  1091,  1091,  1091,  1091,  1091,  1091,-32768,-32768,  1091,
  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,
  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,
  1129,-32768,     0,-32768,-32768,-32768,-32768,   843,-32768,   886,
   300,   306,   309,   675,   277,-32768,-32768,-32768,   314,   234,
-32768,-32768,-32768,   130,   316,   226,     0,-32768,     0,-32768,
  1129,-32768,   320,-32768,   324,   282,-32768,   326,   284,-32768,
-32768,-32768,   127,  1091,   143,   929,   145,   972,   251,   186,
-32768,-32768,-32768,     3,   267,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   123,   123,
   123,   153,   153,   100,   100,   178,   178,   178,   178,   195,
   195,   188,    76,    98,   137,   188,   212,   257,-32768,-32768,
-32768,-32768,   572,   572,  1129,  1015,  1129,     0,-32768,-32768,
     0,   -32,-32768,   334,-32768,-32768,     0,     0,     0,     0,
     0,   258,-32768,   113,-32768,  1091,-32768,  1091,-32768,   217,
-32768,-32768,   219,  1167,   221,-32768,  1091,-32768,  1091,   310,
-32768,   339,   572,   344,   345,    21,-32768,-32768,   -32,   348,
   349,    20,   351,    20,-32768,     0,-32768,-32768,   290,-32768,
-32768,  1053,-32768,-32768,   572,   276,-32768,   572,   572,   -32,
   360,-32768,   -32,   -32,    13,-32768,   -32,-32768,-32768,     6,
   223,-32768,-32768,-32768,-32768,-32768,   -32,-32768,-32768,   318,
   160,     0,     0,     0,-32768,   126,-32768,-32768,-32768,-32768,
-32768,-32768,   160,     0,    46,   364,-32768,-32768,    47,   365,
-32768,   -32,     0,     0,-32768,     0,   -32,-32768,     0,-32768,
-32768,   301,   366,-32768,   369,   -32,   -32,-32768,-32768,   375,
   376,-32768
};

static const short yypgoto[] = {-32768,
    19,   236,-32768,-32768,-32768,   252,    51,     5,    22,   102,
   141,   144,    58,   135,   -31,   216,   211,   242,-32768,   209,
-32768,    84,    18,-32768,-32768,    15,    -3,-32768,   -14,-32768,
   200,-32768,-32768,-32768,-32768,-32768,-32768,   229,  -240,    49,
  -196,-32768,-32768,   110,-32768,    69,-32768,  -242,   227,   -16,
   238,   -12,    -4,    -6,-32768,-32768,   356,-32768,-32768
};


#define	YYLAST		1239


static const short yytable[] = {   104,
   274,   111,   114,   107,   120,    97,   103,   296,    89,   135,
   135,   112,   112,   112,   112,    -9,    84,   121,   122,   123,
    87,    87,    83,    90,    90,   330,   170,   124,    99,   105,
   307,   109,   173,   133,   137,   138,   139,   140,   141,   142,
   143,   144,   145,   146,   147,   148,   149,   173,   106,    37,
   101,   126,   213,   100,   173,   129,   130,   131,   350,   211,
   351,    28,    18,   352,   353,   354,   115,    28,   116,    93,
   214,   297,   136,   136,   212,   102,   173,   173,    -9,   120,
   310,   311,    28,   313,    28,   185,     2,   171,   112,   112,
     3,     4,   359,   196,   184,   355,   150,    94,   113,   126,
   203,   335,   205,   372,   377,   208,    28,   181,   182,   206,
   373,   373,   209,   359,   374,   374,    28,   115,   216,   218,
   118,   199,   119,   371,    98,   199,    80,    37,    37,   118,
   222,   125,   381,   252,   151,    28,   200,   256,    28,   224,
   204,    25,    26,    27,    28,    29,    30,    28,    32,    81,
   225,   165,    87,   199,   226,   227,   228,   229,   230,   231,
   232,   233,   234,   235,   236,   199,   259,   237,   207,   155,
   156,   350,   238,   351,   166,    18,   352,   353,   354,   383,
   210,   316,   385,    28,   196,   258,   214,   270,    28,     2,
   157,   158,   112,     3,     4,   261,   317,   261,   271,   282,
   159,   160,   163,   164,   161,   162,   283,   286,   367,   286,
   287,   288,   291,   288,   167,   276,   246,   247,   248,   249,
   290,    28,   293,   168,   364,   152,   153,   154,   169,    80,
   172,   285,   173,    87,   106,    87,    82,   176,    90,   183,
    91,    92,   148,   149,    25,    26,    27,    28,    29,    30,
   186,    32,    81,   239,   240,   241,   187,   308,   196,   300,
   301,   177,   178,   306,   196,   196,   188,   196,   127,    82,
    82,    82,   179,   180,   312,   189,   314,   -94,   -94,   302,
   304,   305,   219,   220,   320,   297,   321,   297,   -95,   -95,
   361,   297,   319,   331,   332,   242,   243,   250,   251,   327,
   244,   245,   197,   318,   263,    87,   201,   192,   198,   339,
   264,   323,   265,   267,   261,   346,   175,   268,   348,   349,
   272,   342,   360,   277,   344,   345,   341,   278,   279,   280,
   281,   294,   362,   218,   298,   114,   299,   120,   309,    87,
   340,   315,   325,   326,   366,   112,   112,   112,   328,   329,
   375,   196,   333,   334,   378,   337,   370,   380,   297,   343,
   196,   196,   384,   196,   347,   363,   196,   376,   379,   271,
   386,   388,   389,   387,   391,   392,   215,   254,   257,     1,
     2,   253,   324,   266,     3,     4,    82,    82,    82,    82,
    82,    82,    82,    82,    82,    82,    82,    82,    82,    82,
    82,    82,    82,    82,    82,    82,     5,     6,     7,   255,
     8,     9,    10,   369,    11,    12,    13,    14,   269,    15,
    16,    17,   382,   338,   368,   275,    18,    19,    20,    21,
    22,    23,    24,   273,   174,    25,    26,    27,    28,    29,
    30,    31,    32,    33,     1,     2,    34,    35,    36,     3,
     4,     0,     0,     0,     0,   295,     0,     0,    37,     0,
    38,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     5,     6,     7,     0,     8,     9,    10,     0,    11,
    12,    13,    14,     0,    15,    16,    17,     0,     0,     0,
     0,    18,    19,    95,    96,     0,    23,    24,     0,     0,
    25,    26,    27,    28,    29,    30,    31,    32,    33,     1,
     2,    34,    35,    36,     3,     4,     0,     0,     0,     0,
     0,     0,     0,    37,   132,    38,     0,     0,     0,     0,
     0,     0,     0,     0,    82,     0,     5,     6,     7,     0,
     8,     9,    10,     0,    11,    12,    13,    14,     0,    15,
    16,    17,     0,     0,     0,     0,    18,    19,    95,    96,
     0,    23,    24,     0,     0,    25,    26,    27,    28,    29,
    30,    31,    32,    33,     1,     2,    34,    35,    36,     3,
     4,     0,     0,     0,     0,     0,     0,     0,    37,   221,
    38,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     5,     6,     7,     0,     8,     9,    10,     0,    11,
    12,    13,    14,     0,    15,    16,    17,     0,     0,     0,
     0,    18,    19,    95,    96,     0,    23,    24,     0,     0,
    25,    26,    27,    28,    29,    30,    31,    32,    33,     1,
     2,    34,    35,    36,     3,     4,     0,     0,     0,     0,
     0,     0,     0,    37,     0,    38,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     5,     6,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     1,     2,     0,
    80,     0,     3,     4,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    25,    26,    27,    28,    29,
    30,     0,    32,    33,     5,     6,    34,    35,    36,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    80,     0,
   108,     1,     2,     0,     0,     0,     3,     4,     0,     0,
     0,     0,     0,    25,    26,    27,    28,    29,    30,     0,
    32,    33,     0,     0,    34,    35,    36,     0,     5,     6,
     0,     0,     0,     0,     0,     0,     0,     0,    38,     0,
     0,     0,    80,     0,     1,     2,     0,     0,     0,     3,
     4,     0,     0,     0,     0,     0,     0,    25,    26,    27,
    28,    29,    30,     0,    32,    81,    85,     0,    34,    35,
    36,     5,     6,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    80,     0,     1,     2,   223,
     0,     0,     3,     4,     0,     0,     0,     0,     0,     0,
    25,    26,    27,    28,    29,    30,     0,    32,    81,    88,
     0,    34,    35,    36,     5,     6,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     1,     2,     0,    80,     0,
     3,     4,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    25,    26,    27,    28,    29,    30,     0,
    32,    81,     5,     6,    34,    35,    36,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    80,     0,     1,     2,
     0,     0,     0,     3,     4,     0,     0,     0,     0,     0,
     0,    25,    26,    27,    28,    29,    30,     0,    32,    81,
   260,     0,    34,    35,    36,     5,     6,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    80,
     0,     1,     2,     0,     0,     0,     3,     4,     0,     0,
     0,     0,     0,     0,    25,    26,    27,    28,    29,    30,
     0,    32,    81,   262,     0,    34,    35,    36,     5,     6,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    80,     0,     1,     2,     0,     0,     0,     3,
     4,     0,     0,     0,     0,     0,     0,    25,    26,    27,
    28,    29,    30,     0,    32,    81,   289,     0,    34,    35,
    36,     5,     6,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    80,     0,     1,     2,   303,
     0,     0,     3,     4,     0,     0,     0,     0,     0,     0,
    25,    26,    27,    28,    29,    30,     0,    32,    81,   292,
     0,    34,    35,    36,     5,     6,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     1,     2,     0,    80,     0,
     3,     4,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    25,    26,    27,    28,    29,    30,     0,
    32,    33,     5,     6,    34,    35,    36,     0,     0,     0,
     0,     0,     0,     1,     2,     0,    80,     0,     3,     4,
     0,   125,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    25,    26,    27,    28,    29,    30,     0,    32,    81,
     5,     6,    34,    35,    36,     0,     0,     0,     0,     0,
     0,     1,     2,     0,    80,     0,     3,     4,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    25,
    26,    27,    28,    29,    30,     0,    32,    81,     5,     6,
    34,    35,    36,     0,     0,     0,     0,     0,     0,     1,
     2,     0,    80,     0,     3,     4,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    25,    26,    27,
    28,    29,    30,     0,    32,    33,     5,     6,    34,    35,
    36,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    80,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    25,    26,    27,    28,    29,
    30,     0,    32,   322,     0,     0,    34,    35,    36
};

static const short yycheck[] = {    14,
   197,    18,    19,    16,    21,     9,    13,     5,     4,     4,
     4,    18,    19,    20,    21,     4,     2,    22,    23,    24,
     3,     4,     1,     5,     6,     5,    18,    31,    59,    15,
   271,    17,    57,    37,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    30,    31,    57,     4,    82,
    59,    33,    55,    84,    57,    34,    35,    36,    46,    84,
    48,    62,    50,    51,    52,    53,    44,    62,    46,     4,
    65,    69,    67,    67,    84,    84,    57,    57,    67,    96,
   277,   278,    62,   280,    62,    98,     4,    79,    95,    96,
     8,     9,   335,   106,    98,    83,    81,     4,    44,    81,
   113,    82,   115,    58,    58,   118,    62,    93,    94,   116,
    65,    65,   119,   356,    69,    69,    62,    44,   125,   126,
    44,    69,    46,   364,     4,    69,    44,    82,    82,    44,
   134,    49,   373,   165,    12,    62,    84,   169,    62,   135,
    84,    59,    60,    61,    62,    63,    64,    62,    66,    67,
   136,    76,   135,    69,   137,   138,   139,   140,   141,   142,
   143,   144,   145,   146,   147,    69,   173,   150,    84,    70,
    71,    46,   151,    48,    77,    50,    51,    52,    53,   376,
    84,    69,   379,    62,   197,   171,    65,    58,    62,     4,
    13,    14,   199,     8,     9,   178,    84,   180,    69,    73,
     6,     7,    15,    16,    10,    11,   213,    65,    83,    65,
    68,    69,    68,    69,    78,   201,   159,   160,   161,   162,
   216,    62,   218,    37,    65,    73,    74,    75,    17,    44,
    84,   214,    57,   216,     4,   218,     1,     5,   220,    34,
     5,     6,    30,    31,    59,    60,    61,    62,    63,    64,
    84,    66,    67,   152,   153,   154,    84,   272,   271,   263,
   264,    68,    69,   268,   277,   278,    84,   280,    33,    34,
    35,    36,    68,    69,   279,    42,   281,    68,    69,   265,
   266,   267,    68,    69,    68,    69,    68,    69,    68,    69,
    68,    69,   288,   306,   309,   155,   156,   163,   164,   303,
   157,   158,     4,   286,     5,   288,    81,    84,    84,   316,
     5,   294,     4,    37,   297,   330,    81,     4,   333,   334,
     5,   325,   337,     4,   328,   329,   322,     4,    47,     4,
    47,    81,   347,   340,    68,   352,    80,   354,     5,   322,
   322,    84,    33,     5,   351,   352,   353,   354,     5,     5,
   365,   364,     5,     5,   369,     5,   363,   372,    69,    84,
   373,   374,   377,   376,     5,    48,   379,     4,     4,    69,
     5,   386,   387,     5,     0,     0,   125,   167,   170,     3,
     4,   166,   299,   184,     8,     9,   151,   152,   153,   154,
   155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
   165,   166,   167,   168,   169,   170,    30,    31,    32,   168,
    34,    35,    36,   363,    38,    39,    40,    41,   190,    43,
    44,    45,   374,   314,   356,   199,    50,    51,    52,    53,
    54,    55,    56,   196,    79,    59,    60,    61,    62,    63,
    64,    65,    66,    67,     3,     4,    70,    71,    72,     8,
     9,    -1,    -1,    -1,    -1,   220,    -1,    -1,    82,    -1,
    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    30,    31,    32,    -1,    34,    35,    36,    -1,    38,
    39,    40,    41,    -1,    43,    44,    45,    -1,    -1,    -1,
    -1,    50,    51,    52,    53,    -1,    55,    56,    -1,    -1,
    59,    60,    61,    62,    63,    64,    65,    66,    67,     3,
     4,    70,    71,    72,     8,     9,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    82,    83,    84,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   299,    -1,    30,    31,    32,    -1,
    34,    35,    36,    -1,    38,    39,    40,    41,    -1,    43,
    44,    45,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
    -1,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
    64,    65,    66,    67,     3,     4,    70,    71,    72,     8,
     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,    83,
    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    30,    31,    32,    -1,    34,    35,    36,    -1,    38,
    39,    40,    41,    -1,    43,    44,    45,    -1,    -1,    -1,
    -1,    50,    51,    52,    53,    -1,    55,    56,    -1,    -1,
    59,    60,    61,    62,    63,    64,    65,    66,    67,     3,
     4,    70,    71,    72,     8,     9,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,
    44,    -1,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    59,    60,    61,    62,    63,
    64,    -1,    66,    67,    30,    31,    70,    71,    72,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,
    84,     3,     4,    -1,    -1,    -1,     8,     9,    -1,    -1,
    -1,    -1,    -1,    59,    60,    61,    62,    63,    64,    -1,
    66,    67,    -1,    -1,    70,    71,    72,    -1,    30,    31,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,
    -1,    -1,    44,    -1,     3,     4,    -1,    -1,    -1,     8,
     9,    -1,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,
    62,    63,    64,    -1,    66,    67,    68,    -1,    70,    71,
    72,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    44,    -1,     3,     4,     5,
    -1,    -1,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
    59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
    -1,    70,    71,    72,    30,    31,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,    44,    -1,
     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    59,    60,    61,    62,    63,    64,    -1,
    66,    67,    30,    31,    70,    71,    72,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,     3,     4,
    -1,    -1,    -1,     8,     9,    -1,    -1,    -1,    -1,    -1,
    -1,    59,    60,    61,    62,    63,    64,    -1,    66,    67,
    68,    -1,    70,    71,    72,    30,    31,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
    -1,     3,     4,    -1,    -1,    -1,     8,     9,    -1,    -1,
    -1,    -1,    -1,    -1,    59,    60,    61,    62,    63,    64,
    -1,    66,    67,    68,    -1,    70,    71,    72,    30,    31,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    44,    -1,     3,     4,    -1,    -1,    -1,     8,
     9,    -1,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,
    62,    63,    64,    -1,    66,    67,    68,    -1,    70,    71,
    72,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    44,    -1,     3,     4,     5,
    -1,    -1,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
    59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
    -1,    70,    71,    72,    30,    31,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,    44,    -1,
     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    59,    60,    61,    62,    63,    64,    -1,
    66,    67,    30,    31,    70,    71,    72,    -1,    -1,    -1,
    -1,    -1,    -1,     3,     4,    -1,    44,    -1,     8,     9,
    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    59,    60,    61,    62,    63,    64,    -1,    66,    67,
    30,    31,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,
    -1,     3,     4,    -1,    44,    -1,     8,     9,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,
    60,    61,    62,    63,    64,    -1,    66,    67,    30,    31,
    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,     3,
     4,    -1,    44,    -1,     8,     9,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,
    62,    63,    64,    -1,    66,    67,    30,    31,    70,    71,
    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    59,    60,    61,    62,    63,
    64,    -1,    66,    67,    -1,    -1,    70,    71,    72
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/misc/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/misc/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 145 "elastic_p.y"
{ yyval.ast = makeConstInt( yyvsp[0].icnst );   SAVE(yyval.ast, yylsp[0]);                 ;
    break;}
case 2:
#line 146 "elastic_p.y"
{ yyval.ast = makeConstFloat( yyvsp[0].fcnst ); SAVE(yyval.ast, yylsp[0]);                 ;
    break;}
case 3:
#line 147 "elastic_p.y"
{ yyval.ast = makeConstChar( yyvsp[0].ccnst );  SAVE(yyval.ast, yylsp[0]);                 ;
    break;}
case 4:
#line 148 "elastic_p.y"
{ yyval.ast = makeConstSym( yyvsp[0].sym );   SAVE(yyval.ast, yylsp[0]);                 ;
    break;}
case 5:
#line 149 "elastic_p.y"
{ yyval.ast = makeConstString( yyvsp[0].strcnst ); ec_free( yyvsp[0].strcnst ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 6:
#line 150 "elastic_p.y"
{ yyval.ast = makeConstObject( yyvsp[0].objcnst ); SAVE(yyval.ast, yylsp[0]);                ;
    break;}
case 7:
#line 151 "elastic_p.y"
{ yyval.ast = yyvsp[-1].ast;                                                 ;
    break;}
case 8:
#line 156 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                           ;
    break;}
case 9:
#line 157 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                           ;
    break;}
case 10:
#line 158 "elastic_p.y"
{ yyval.ast = makeFunction( NULL, NULL, yyvsp[-2].ast, yyvsp[0].ast );
								     if (yyvsp[0].ast) yyvsp[0].ast->vStmtList.retVal = TRUE; SAVE(yyval.ast, yylsp[-4]); ;
    break;}
case 11:
#line 160 "elastic_p.y"
{ yyval.ast = makeCall( yyvsp[-2].ast, NULL ); SAVE(yyval.ast, yylsp[-2]);           ;
    break;}
case 12:
#line 161 "elastic_p.y"
{ yyval.ast = makeCall( yyvsp[-3].ast,   yyvsp[-1].ast ); SAVE(yyval.ast, yylsp[-3]);           ;
    break;}
case 13:
#line 162 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                           ;
    break;}
case 14:
#line 163 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                           ;
    break;}
case 15:
#line 164 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                           ;
    break;}
case 16:
#line 168 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                   ;
    break;}
case 17:
#line 169 "elastic_p.y"
{ yyval.ast = makeArrayRef( yyvsp[-3].ast, yyvsp[-1].ast ); SAVE(yyval.ast, yylsp[-3]); ;
    break;}
case 18:
#line 173 "elastic_p.y"
{ yyval.ast = makeMethodCall( FALSE, yyvsp[-2].ast, yyvsp[-1].ast, NULL ); SAVE(yyval.ast, yylsp[-3]);    ;
    break;}
case 19:
#line 174 "elastic_p.y"
{ yyval.ast = makeMethodCall( FALSE, yyvsp[-3].ast, yyvsp[-2].ast, yyvsp[-1].ast );   SAVE(yyval.ast, yylsp[-4]);    ;
    break;}
case 20:
#line 175 "elastic_p.y"
{ yyval.ast = makeMethodCall( FALSE, yyvsp[-2].ast,
                                                                                          makeSymbol( yyvsp[-1].kwl.sym ), yyvsp[-1].kwl.list ); SAVE(yyval.ast, yylsp[-3]);  ;
    break;}
case 21:
#line 177 "elastic_p.y"
{ yyval.ast = makeMethodCall( TRUE, NULL, yyvsp[-1].ast, NULL ); SAVE(yyval.ast, yylsp[-3]);    ;
    break;}
case 22:
#line 178 "elastic_p.y"
{ yyval.ast = makeMethodCall( TRUE, NULL, yyvsp[-2].ast, yyvsp[-1].ast );   SAVE(yyval.ast, yylsp[-4]);    ;
    break;}
case 23:
#line 179 "elastic_p.y"
{ yyval.ast = makeMethodCall( TRUE, NULL,
                                                                               makeSymbol( yyvsp[-1].kwl.sym ), yyvsp[-1].kwl.list ); SAVE(yyval.ast, yylsp[-3]);  ;
    break;}
case 24:
#line 184 "elastic_p.y"
{ yyval.ast = makeArrayCons( NULL ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 25:
#line 185 "elastic_p.y"
{ yyval.ast = makeArrayCons( yyvsp[-1].ast );   SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 26:
#line 186 "elastic_p.y"
{ yyval.ast = makeArrayCons( yyvsp[-2].ast );   SAVE(yyval.ast, yylsp[-3]); ;
    break;}
case 27:
#line 190 "elastic_p.y"
{ yyval.ast = makeHashCons( NULL ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 28:
#line 191 "elastic_p.y"
{ yyval.ast = makeHashCons( yyvsp[-1].ast );   SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 29:
#line 192 "elastic_p.y"
{ yyval.ast = makeHashCons( yyvsp[-2].ast );   SAVE(yyval.ast, yylsp[-3]); ;
    break;}
case 30:
#line 196 "elastic_p.y"
{ yyval.kwl.sym = yyvsp[-1].sym;
                                                                     yyval.kwl.list = makeList( TRUE, FALSE, NULL, yyvsp[0].ast ); SAVE(yyval.kwl.list, yylsp[-1]);    ;
    break;}
case 31:
#line 198 "elastic_p.y"
{ yyval.kwl.sym = symconcat( yyvsp[-2].kwl.sym, yyvsp[-1].sym );
                                                                     yyval.kwl.list = makeList( TRUE, FALSE, yyvsp[-2].kwl.list, yyvsp[0].ast ); SAVE(yyval.kwl.list, yylsp[-2]); ;
    break;}
case 32:
#line 200 "elastic_p.y"
{ yyval.kwl.sym = yyvsp[-2].kwl.sym;
                                                                     yyval.kwl.list = listconcat( yyvsp[-2].kwl.list, yyvsp[0].ast ); SAVE(yyval.kwl.list, yylsp[-2]); ;
    break;}
case 33:
#line 205 "elastic_p.y"
{ yyval.kwl.sym = yyvsp[-1].sym;
                                                                     yyval.kwl.list = makeList( TRUE, FALSE, NULL, yyvsp[0].ast ); SAVE(yyval.kwl.list, yylsp[-1]);    ;
    break;}
case 34:
#line 207 "elastic_p.y"
{ yyval.kwl.sym = symconcat( yyvsp[-2].kwl.sym, yyvsp[-1].sym );
                                                                     yyval.kwl.list = makeList( TRUE, FALSE, yyvsp[-2].kwl.list, yyvsp[0].ast ); SAVE(yyval.kwl.list, yylsp[-2]); ;
    break;}
case 35:
#line 209 "elastic_p.y"
{ yyval.kwl.sym = yyvsp[-2].kwl.sym;
                                                                     yyval.kwl.list = listconcat( yyvsp[-2].kwl.list, yyvsp[0].ast ); SAVE(yyval.kwl.list, yylsp[-2]); ;
    break;}
case 36:
#line 214 "elastic_p.y"
{ yyval.ast = makeList( TRUE, FALSE, NULL, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 37:
#line 215 "elastic_p.y"
{ yyval.ast = makeList( TRUE, FALSE, yyvsp[-2].ast, yyvsp[0].ast );   SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 38:
#line 219 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                        ;
    break;}
case 39:
#line 220 "elastic_p.y"
{ yyval.ast = makeUnary( POS_OP, yyvsp[0].ast );     SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 40:
#line 221 "elastic_p.y"
{ yyval.ast = makeUnary( NEG_OP, yyvsp[0].ast );     SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 41:
#line 222 "elastic_p.y"
{ yyval.ast = makeUnary( INVERT_OP, yyvsp[0].ast );  SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 42:
#line 223 "elastic_p.y"
{ yyval.ast = makeUnary( LNOT_OP, yyvsp[0].ast );    SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 43:
#line 224 "elastic_p.y"
{ yyval.ast = makeUnary( PREINC_OP, yyvsp[0].ast );  SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 44:
#line 225 "elastic_p.y"
{ yyval.ast = makeUnary( PREDEC_OP, yyvsp[0].ast );  SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 45:
#line 226 "elastic_p.y"
{ yyval.ast = makeUnary( POSTINC_OP, yyvsp[-1].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 46:
#line 227 "elastic_p.y"
{ yyval.ast = makeUnary( POSTDEC_OP, yyvsp[-1].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 47:
#line 231 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                         ;
    break;}
case 48:
#line 232 "elastic_p.y"
{ yyval.ast = makeBinary( POW_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 49:
#line 236 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                         ;
    break;}
case 50:
#line 237 "elastic_p.y"
{ yyval.ast = makeBinary( MUL_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 51:
#line 238 "elastic_p.y"
{ yyval.ast = makeBinary( DIV_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 52:
#line 239 "elastic_p.y"
{ yyval.ast = makeBinary( MOD_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 54:
#line 244 "elastic_p.y"
{ yyval.ast = makeBinary( ADD_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 55:
#line 245 "elastic_p.y"
{ yyval.ast = makeBinary( SUB_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 57:
#line 250 "elastic_p.y"
{ yyval.ast = makeBinary( LSHIFT_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 58:
#line 251 "elastic_p.y"
{ yyval.ast = makeBinary( RSHIFT_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 59:
#line 255 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                        ;
    break;}
case 60:
#line 256 "elastic_p.y"
{ yyval.ast = makeBinary( LT_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 61:
#line 257 "elastic_p.y"
{ yyval.ast = makeBinary( GT_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 62:
#line 258 "elastic_p.y"
{ yyval.ast = makeBinary( LE_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 63:
#line 259 "elastic_p.y"
{ yyval.ast = makeBinary( GE_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 64:
#line 263 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                          SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 65:
#line 264 "elastic_p.y"
{ yyval.ast = makeBinary( EQ_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 66:
#line 265 "elastic_p.y"
{ yyval.ast = makeBinary( NE_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 67:
#line 269 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                         ;
    break;}
case 68:
#line 270 "elastic_p.y"
{ yyval.ast = makeBinary( AND_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 69:
#line 274 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                         ;
    break;}
case 70:
#line 275 "elastic_p.y"
{ yyval.ast = makeBinary( XOR_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 71:
#line 279 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                        ;
    break;}
case 72:
#line 280 "elastic_p.y"
{ yyval.ast = makeBinary( OR_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 73:
#line 284 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                        ;
    break;}
case 74:
#line 285 "elastic_p.y"
{ yyval.ast = makeBinary( IN_OP, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 75:
#line 289 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                              ;
    break;}
case 76:
#line 290 "elastic_p.y"
{ yyval.ast = makeAnd( yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 77:
#line 294 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                             ;
    break;}
case 78:
#line 295 "elastic_p.y"
{ yyval.ast = makeOr( yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 79:
#line 299 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                            ;
    break;}
case 80:
#line 301 "elastic_p.y"
{ yyval.ast = makeConditional( yyvsp[-4].ast, yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-3]); ;
    break;}
case 81:
#line 305 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                                 ;
    break;}
case 82:
#line 306 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 83:
#line 307 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, makeBinary( POW_OP, yyvsp[-2].ast, yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[-1]);    ;
    break;}
case 84:
#line 308 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, makeBinary( MUL_OP, yyvsp[-2].ast, yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[-1]);    ;
    break;}
case 85:
#line 309 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, makeBinary( DIV_OP, yyvsp[-2].ast, yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[-1]);    ;
    break;}
case 86:
#line 310 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, makeBinary( MOD_OP, yyvsp[-2].ast, yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[-1]);    ;
    break;}
case 87:
#line 311 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, makeBinary( ADD_OP, yyvsp[-2].ast, yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[-1]);    ;
    break;}
case 88:
#line 312 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, makeBinary( SUB_OP, yyvsp[-2].ast, yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[-1]);    ;
    break;}
case 89:
#line 313 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, makeBinary( LSHIFT_OP, yyvsp[-2].ast, yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 90:
#line 314 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, makeBinary( RSHIFT_OP, yyvsp[-2].ast, yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 91:
#line 315 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, makeBinary( AND_OP, yyvsp[-2].ast, yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[-1]);    ;
    break;}
case 92:
#line 316 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, makeBinary( XOR_OP, yyvsp[-2].ast, yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[-1]);    ;
    break;}
case 93:
#line 317 "elastic_p.y"
{ yyval.ast = makeAssign( yyvsp[-2].ast, makeBinary( OR_OP, yyvsp[-2].ast, yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[-1]);     ;
    break;}
case 94:
#line 321 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE, NULL, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 95:
#line 322 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE, yyvsp[-2].ast, yyvsp[0].ast );   SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 96:
#line 326 "elastic_p.y"
{ yyval.ast = makeSimultaneousAssign( yyvsp[-5].ast, yyvsp[-1].ast ); SAVE(yyval.ast, yylsp[-3]); ;
    break;}
case 97:
#line 327 "elastic_p.y"
{ yyval.ast = makeSimultaneousAssign( yyvsp[-3].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 98:
#line 331 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                           ;
    break;}
case 99:
#line 332 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;                           ;
    break;}
case 100:
#line 336 "elastic_p.y"
{ yyval.ast = makeStmt( yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 101:
#line 337 "elastic_p.y"
{ yyval.ast = makeStmt( yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 102:
#line 338 "elastic_p.y"
{ yyval.ast = makeStmt( makeExprStmt( yyvsp[0].ast ) ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 103:
#line 339 "elastic_p.y"
{ yyval.ast = makeStmt( yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 104:
#line 340 "elastic_p.y"
{ yyval.ast = makeStmt( yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 105:
#line 341 "elastic_p.y"
{ yyval.ast = makeStmt( yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 106:
#line 342 "elastic_p.y"
{ yyval.ast = makeStmt( yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 107:
#line 343 "elastic_p.y"
{ yyval.ast = makeStmt( yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 108:
#line 344 "elastic_p.y"
{ yyval.ast = makeStmt( yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 109:
#line 345 "elastic_p.y"
{ yyval.ast = makeStmt( yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 110:
#line 349 "elastic_p.y"
{ yyval.ast = makeLabeledStmt( yyvsp[-1].sym, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 111:
#line 353 "elastic_p.y"
{ yyval.ast = NULL; ;
    break;}
case 112:
#line 354 "elastic_p.y"
{ yyval.ast = yyvsp[-1].ast;   ;
    break;}
case 113:
#line 358 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE, NULL, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 114:
#line 359 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE,   yyvsp[-1].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 115:
#line 363 "elastic_p.y"
{ yyval.ast = NULL; ;
    break;}
case 116:
#line 364 "elastic_p.y"
{ yyval.ast = yyvsp[-1].ast;   ;
    break;}
case 117:
#line 368 "elastic_p.y"
{ yyval.ast = makeIf( yyvsp[-2].ast, yyvsp[0].ast, NULL ); SAVE(yyval.ast, yylsp[-4]); ;
    break;}
case 118:
#line 369 "elastic_p.y"
{ yyval.ast = makeIf( yyvsp[-4].ast, yyvsp[-2].ast,   yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-6]); ;
    break;}
case 119:
#line 373 "elastic_p.y"
{ yyval.ast = makeWhile( yyvsp[-2].ast, yyvsp[0].ast );         SAVE(yyval.ast, yylsp[-4]); ;
    break;}
case 120:
#line 374 "elastic_p.y"
{ yyval.ast = makeDo( yyvsp[-2].ast, yyvsp[-5].ast );            SAVE(yyval.ast, yylsp[-6]); ;
    break;}
case 121:
#line 375 "elastic_p.y"
{ yyval.ast = makeFor( yyvsp[-3].ast, yyvsp[-2].ast, NULL, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-5]); ;
    break;}
case 122:
#line 376 "elastic_p.y"
{ yyval.ast = makeFor( yyvsp[-4].ast, yyvsp[-3].ast,   yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-6]); ;
    break;}
case 123:
#line 377 "elastic_p.y"
{ yyval.ast = makeForIn( yyvsp[-4].ast, yyvsp[-2].ast, yyvsp[0].ast );     SAVE(yyval.ast, yylsp[-6]); ;
    break;}
case 124:
#line 381 "elastic_p.y"
{ yyval.ast = makeReturn( NULL );                 SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 125:
#line 382 "elastic_p.y"
{ yyval.ast = makeReturn( yyvsp[-1].ast );                   SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 126:
#line 383 "elastic_p.y"
{ yyval.ast = makeBreak( NULL );                  SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 127:
#line 384 "elastic_p.y"
{ yyval.ast = makeBreak( makeConstInt( yyvsp[-1].icnst ) );    SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 128:
#line 385 "elastic_p.y"
{ yyval.ast = makeContinue( NULL );               SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 129:
#line 386 "elastic_p.y"
{ yyval.ast = makeContinue( makeConstInt( yyvsp[-1].icnst ) ); SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 130:
#line 387 "elastic_p.y"
{ yyval.ast = makeGoto( yyvsp[-1].ast );                     SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 131:
#line 388 "elastic_p.y"
{ yyval.ast = makeThrow( yyvsp[-1].ast );                    SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 132:
#line 392 "elastic_p.y"
{ yyval.ast = makeImport( FALSE, yyvsp[-1].ast, NULL);  SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 133:
#line 393 "elastic_p.y"
{ yyval.ast = makeImport( TRUE,  yyvsp[-3].ast, yyvsp[-1].ast );   SAVE(yyval.ast, yylsp[-4]); ;
    break;}
case 134:
#line 394 "elastic_p.y"
{ yyval.ast = makeImport( TRUE,  yyvsp[-3].ast, NULL ); SAVE(yyval.ast, yylsp[-4]); ;
    break;}
case 135:
#line 398 "elastic_p.y"
{ yyval.ast = makeTry( yyvsp[-1].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 136:
#line 402 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE, NULL, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 137:
#line 403 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE,   yyvsp[-1].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 138:
#line 407 "elastic_p.y"
{ yyval.ast = makeCatch( yyvsp[-2].ast, NULL, yyvsp[0].ast );  SAVE(yyval.ast, yylsp[-4]); ;
    break;}
case 139:
#line 408 "elastic_p.y"
{ yyval.ast = makeCatch( yyvsp[-3].ast,   yyvsp[-2].ast, yyvsp[0].ast );  SAVE(yyval.ast, yylsp[-5]); ;
    break;}
case 140:
#line 414 "elastic_p.y"
{ yyval.ast = makeParam( yyvsp[-1].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]);               ;
    break;}
case 141:
#line 418 "elastic_p.y"
{ yyval.ast = makeList( TRUE, FALSE, NULL, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 142:
#line 419 "elastic_p.y"
{ yyval.ast = makeList( TRUE, FALSE,   yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 143:
#line 423 "elastic_p.y"
{ yyval.ast = makeParamList( FALSE, NULL ); SAVE(yyval.ast, yylsp[1]);       ;
    break;}
case 144:
#line 424 "elastic_p.y"
{ yyval.ast = makeParamList( FALSE, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]);         ;
    break;}
case 145:
#line 425 "elastic_p.y"
{ yyval.ast = makeParamList( TRUE,  yyvsp[-1].ast ); SAVE(yyval.ast, yylsp[-1]);         ;
    break;}
case 146:
#line 432 "elastic_p.y"
{ yyval.ast = makeFunction( yyvsp[-4].ast, DECLVAR( SymbolLocal,   yyvsp[-4].ast ), yyvsp[-2].ast, yyvsp[0].ast ); if (yyvsp[0].ast) yyvsp[0].ast->vStmtList.retVal = TRUE; SAVE(yyval.ast, yylsp[-5]); ;
    break;}
case 147:
#line 434 "elastic_p.y"
{ yyval.ast = makeFunction( yyvsp[-4].ast, DECLVAR( SymbolStatic,  yyvsp[-4].ast ), yyvsp[-2].ast, yyvsp[0].ast ); if (yyvsp[0].ast) yyvsp[0].ast->vStmtList.retVal = TRUE; SAVE(yyval.ast, yylsp[-6]); ;
    break;}
case 148:
#line 436 "elastic_p.y"
{ yyval.ast = makeFunction( yyvsp[-4].ast, DECLVAR( SymbolPrivate, yyvsp[-4].ast ), yyvsp[-2].ast, yyvsp[0].ast ); if (yyvsp[0].ast) yyvsp[0].ast->vStmtList.retVal = TRUE; SAVE(yyval.ast, yylsp[-6]); ;
    break;}
case 149:
#line 438 "elastic_p.y"
{ yyval.ast = makeFunction( yyvsp[-4].ast, DECLVAR( SymbolPublic,  yyvsp[-4].ast ), yyvsp[-2].ast, yyvsp[0].ast ); if (yyvsp[0].ast) yyvsp[0].ast->vStmtList.retVal = TRUE; SAVE(yyval.ast, yylsp[-6]); ;
    break;}
case 150:
#line 445 "elastic_p.y"
{ yyval.ast = makeClass( DECLSYM( SymbolPrivate, yyvsp[-3].ast ), yyvsp[-3].ast, yyvsp[-1].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-5]); ;
    break;}
case 151:
#line 447 "elastic_p.y"
{ yyval.ast = makeClass( DECLSYM( SymbolPublic, yyvsp[-3].ast ), yyvsp[-3].ast, yyvsp[-1].ast, yyvsp[0].ast );  SAVE(yyval.ast, yylsp[-5]); ;
    break;}
case 152:
#line 451 "elastic_p.y"
{ yyval.ast = NULL; ;
    break;}
case 153:
#line 452 "elastic_p.y"
{ yyval.ast = yyvsp[-1].ast;   ;
    break;}
case 154:
#line 456 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE, NULL, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 155:
#line 457 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE,   yyvsp[-1].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 156:
#line 461 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast; ;
    break;}
case 157:
#line 462 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast; ;
    break;}
case 158:
#line 467 "elastic_p.y"
{ yyval.ast = makeMethod( FALSE, yyvsp[-4].ast, yyvsp[-2].ast, yyvsp[0].ast ); if (yyvsp[0].ast) yyvsp[0].ast->vStmtList.retVal = TRUE; SAVE(yyval.ast, yylsp[-5]); ;
    break;}
case 159:
#line 469 "elastic_p.y"
{ yyval.ast = makeMethod( FALSE, makeSymbol( yyvsp[-1].kwl.sym ), makeParamList( FALSE, yyvsp[-1].kwl.list ), yyvsp[0].ast );
		  if (yyvsp[0].ast) yyvsp[0].ast->vStmtList.retVal = TRUE; SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 160:
#line 472 "elastic_p.y"
{ yyval.ast = makeMethod( FALSE, makeSymbol( yyvsp[-2].kwl.sym ), makeParamList( TRUE, yyvsp[-2].kwl.list ), yyvsp[0].ast );
		  if (yyvsp[0].ast) yyvsp[0].ast->vStmtList.retVal = TRUE; SAVE(yyval.ast, yylsp[-3]); ;
    break;}
case 161:
#line 475 "elastic_p.y"
{ yyval.ast = makeMethod( TRUE, yyvsp[-4].ast, yyvsp[-2].ast, yyvsp[0].ast ); if (yyvsp[0].ast) yyvsp[0].ast->vStmtList.retVal = TRUE; SAVE(yyval.ast, yylsp[-6]); ;
    break;}
case 162:
#line 477 "elastic_p.y"
{ yyval.ast = makeMethod( TRUE, makeSymbol( yyvsp[-1].kwl.sym ), makeParamList( FALSE, yyvsp[-1].kwl.list ), yyvsp[0].ast );
		  if (yyvsp[0].ast) yyvsp[0].ast->vStmtList.retVal = TRUE; SAVE(yyval.ast, yylsp[-3]); ;
    break;}
case 163:
#line 480 "elastic_p.y"
{ yyval.ast = makeMethod( TRUE, makeSymbol( yyvsp[-2].kwl.sym ), makeParamList( TRUE, yyvsp[-2].kwl.list ), yyvsp[0].ast );
		  if (yyvsp[0].ast) yyvsp[0].ast->vStmtList.retVal = TRUE; SAVE(yyval.ast, yylsp[-4]); ;
    break;}
case 164:
#line 487 "elastic_p.y"
{ yyval.ast = makeDecl( SymbolLocal,   yyvsp[-1].ast ); SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 165:
#line 488 "elastic_p.y"
{ yyval.ast = makeDecl( SymbolStatic,  yyvsp[-1].ast ); SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 166:
#line 489 "elastic_p.y"
{ yyval.ast = makeDecl( SymbolPrivate, yyvsp[-1].ast ); SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 167:
#line 490 "elastic_p.y"
{ yyval.ast = makeDecl( SymbolPublic,  yyvsp[-1].ast ); SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 168:
#line 494 "elastic_p.y"
{ yyval.ast = makeDeclAtom( yyvsp[-1].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 169:
#line 498 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE, NULL, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 170:
#line 499 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE,   yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 171:
#line 503 "elastic_p.y"
{ yyval.ast = NULL; ;
    break;}
case 172:
#line 504 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast;   ;
    break;}
case 173:
#line 508 "elastic_p.y"
{ yyval.ast = makeVariable( yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 174:
#line 512 "elastic_p.y"
{ yyval.ast = makeQualifiedSymbol( NULL, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 175:
#line 513 "elastic_p.y"
{ yyval.ast = makeQualifiedSymbol( yyvsp[-2].ast,   yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 176:
#line 517 "elastic_p.y"
{ yyval.ast = makeSymbol( EcInternSymbol( yyvsp[0].strcnst ) );
								     ec_free( yyvsp[0].strcnst ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 177:
#line 522 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE, NULL, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 178:
#line 523 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE,   yyvsp[-2].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-2]); ;
    break;}
case 179:
#line 529 "elastic_p.y"
{ yyval.ast = makePackage( yyvsp[-1].ast ); ;
    break;}
case 180:
#line 533 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast; ;
    break;}
case 181:
#line 534 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast; ;
    break;}
case 182:
#line 535 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast; ;
    break;}
case 183:
#line 539 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE, NULL, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[0]); ;
    break;}
case 184:
#line 540 "elastic_p.y"
{ yyval.ast = makeList( FALSE, FALSE,   yyvsp[-1].ast, yyvsp[0].ast ); SAVE(yyval.ast, yylsp[-1]); ;
    break;}
case 185:
#line 546 "elastic_p.y"
{ yyval.ast = yyvsp[0].ast; PRIVATE(parse_result) = yyval.ast; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/misc/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 550 "elastic_p.y"


int yyerror( char *s )  /* Called by yyparse on error */
{
	fprintf( stderr, "ERROR: (LINE: %ld, COLUMN: %ld): %s\n", (long)PRIVATE(line), (long)PRIVATE(column), s );
	return 0;
}

static EcUInt symconcat( EcUInt sym1, EcUInt sym2 )
{
	const char *bsym1;
	const char *bsym2;
	char *buf;

	bsym1 = EcSymbolAt( sym1 );
	bsym2 = EcSymbolAt( sym2 );
	buf = alloca( strlen( bsym1 ) + strlen( bsym2 ) + 1 );
	strcpy( buf, bsym1 );
	strcat( buf, bsym2 );
	return EcInternSymbol( buf );
}

static void saveLoc( ASTLocation *dst, void *vsrc )
{
	YYLTYPE *src;

	src = vsrc;

	if (dst)
	{
		dst->first_line   = src->first_line;
		dst->first_column = src->first_column;
		dst->last_line    = src->last_line;
		dst->last_column  = src->last_column;
	}
}

static ASTNode listconcat( ASTNode l1, ASTNode l2 )
{
	ASTNode node;

	/* Get to the last position in prefix list */
	node = l1;
	while (node)
	{
		if (! node->vStmtList.next) break;

		node = node->vStmtList.next;
	}

	if (node)
	{
		node->vStmtList.next = l2;
	}

	return l1;
}
