typedef union {
	EcInt		icnst;          /* For returning numerical constants	     */
	EcFloat		fcnst;          /* For returning numerical constants	     */
	EcChar          ccnst;          /* For returning char constants	             */
	char           *strcnst;        /* For returning string constants or symbols */
	EC_OBJ          objcnst;        /* For returning object constants	     */
	ASTNode         ast;            /* Abstract Syntax Tree                      */
	EcUInt          sym;            /* Symbol                                    */
	struct {
		EcUInt  sym;
		ASTNode list;
	}               kwl;		/* Keyword Argument / Parameter List         */
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#define	T_ARRAYCONS	257
#define	T_HASHCONS	258
#define	T_LE	259
#define	T_GE	260
#define	T_POW	261
#define	T_LSHIFT	262
#define	T_RSHIFT	263
#define	T_EQ	264
#define	T_NE	265
#define	T_LAND	266
#define	T_LOR	267
#define	T_POWASSIGN	268
#define	T_MULASSIGN	269
#define	T_DIVASSIGN	270
#define	T_MODASSIGN	271
#define	T_ADDASSIGN	272
#define	T_SUBASSIGN	273
#define	T_LSHIFTASSIGN	274
#define	T_RSHIFTASSIGN	275
#define	T_ANDASSIGN	276
#define	T_XORASSIGN	277
#define	T_ORASSIGN	278
#define	T_INC	279
#define	T_DEC	280
#define	T_IF	281
#define	T_ELSE	282
#define	T_WHILE	283
#define	T_DO	284
#define	T_FOR	285
#define	T_IN	286
#define	T_BREAK	287
#define	T_CONTINUE	288
#define	T_GOTO	289
#define	T_TRY	290
#define	T_CATCH	291
#define	T_THROW	292
#define	T_FUNCTION	293
#define	T_RETURN	294
#define	T_CLASS	295
#define	T_EXTENDS	296
#define	T_METHOD	297
#define	T_SUPER	298
#define	T_LOCAL	299
#define	T_STATIC	300
#define	T_PRIVATE	301
#define	T_PUBLIC	302
#define	T_PACKAGE	303
#define	T_IMPORT	304
#define	T_FROM	305
#define	T_QUALIFIER	306
#define	T_ELLIPSIS	307
#define	T_INUMBER	308
#define	T_FNUMBER	309
#define	T_CHAR	310
#define	T_SYMBOL	311
#define	T_STRING	312
#define	T_OBJECT	313
#define	T_KEYWORD	314
#define	T_CONSTSYM	315


extern YYSTYPE yylval;
